/*
 * Copyright (C) 2003-2009 eXo Platform SAS.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.reflext.spi.model;

import org.reflext.api.AccessScope;

import java.lang.annotation.Annotation;

/**
 * @author <a href="mailto:julien.viet@exoplatform.com">Julien Viet</a>
 * @version $Revision$
 */
public interface MethodModel<T, M> {

  Iterable<M> getDeclaredMethods(T classType);

  String getName(M m);

  T getReturnType(M m);

  Iterable<T> getParameterTypes(M m);

  AccessScope getAccess(M m);

  boolean isAbstract(M m);

  boolean isStatic(M m);

  boolean isFinal(M m);

  Iterable<T> getTypeParameters(M m);

  <A extends Annotation> A getDeclaredAnnotation(M method, Class<A> annotationClass);

  M getGenericDeclaration(T typeVariable);

  T getOwner(M m);
}
